<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron"
   queryBinding="xslt2">
 
  <pattern>
    <rule context="section">

      <assert test="child::title">section has no title</assert>
      <assert test="*[not(self::title)]">section has nothing but a title</assert>
      <report test="count(ancestor-or-self::section) > 4">section is more than four deep</report>
    </rule>

    <rule context="para">
      <assert test="normalize-space() or child::*">para has no meaningful content</assert>
      <report test="normalize-space() and (. = preceding::para)">paragraph repeated?</report>
    </rule>

    <rule context="imagedata">
      <assert test="normalize-space(attribute::fileref)">image has no fileref given</assert>
    </rule>

    <rule context="figure">
      <assert test="@id">figure requires an "id" attribute</assert>
      <assert test="@float">figure requires a "float" attribute</assert>
    </rule>
    
    <rule context="ulink">
      <assert test="normalize-space(attribute::url)">ulink has no url given</assert>
    </rule>
    
    <rule context="xref">
      <report test="normalize-space() or *">xref should be empty (its content will be generated)</report>
      <assert test="@linkend = //@id">xref must have @linkend pointing to some @id</assert>
    </rule>
    
  </pattern>

</schema>